/**
* Created by Escape on 16/8/30.
*/
var iFramework = function(selector, context) {
  return new iFramework.fn.init( selector, context );
};
var DOC = window.document;
var W3C = window.dispatchEvent;
var html = DOC.documentElement; //HTML元素
var toString = Object.prototype.toString;
var class2type = {
  "[object HTMLDocument]": "Document",
  "[object HTMLCollection]": "NodeList",
  "[object StaticNodeList]": "NodeList",
  "[object DOMWindow]": "Window",
  "[object global]": "Window",
  "[object boolean]": "boolean",
  "[object number]": "number",
  "[object string]": "string",
  "[object funciton]": "funciton",
  "[object array]": "array",
  "[object date]": "date",
  "[object regexp]": "regexp",
  "[object object]": "object",
  "null": "Null",
  "NaN": "NaN",
  "undefined": "Undefined",
};
/**
 * 多库共存
 * @param  {object}
 * @param  {Node|NodeList|Array|Mass} context ？ 上下文对象
 * @return  {iFramework}
 */
//原型
iFramework.fn = iFramework.prototype = {
  constructor: iFramework,
  /**
   * 类型判断
   * @param    {any}  obj
   * @return  type    类型
   */
  type: function (obj) {
    return obj == null ? String(obj) : class2type[toString.call(obj)] || "object";
  },
};

/**
 * 对象浅复制
 * @param    {object}  source 原对象
 * @param    {object}  target 复制后对象
 * @return  target    新对象
 */
iFramework.extend = iFramework.fn.extend = Object.assign || function (source, target) {
  for (var key in source) {
    if (!(key in target)) {
      target[key] = source[key];
    }
  }
  return target;
};
//============================加载系统===========================
// var modules = $.modules = {
//   ready: {
//     exports: $
//   },
//   base: {
//     state: 2,
//     exports: $
//   }
// };
// //============================domReady机制===========================
// var readyFn, ready = W3C ? "DOMContentLoaded" : "readystatechange";
// function fireReady() {
//   modules.ready.state = 2;
//   checkDeps();
//   if (readyFn) {
//     $.unbind(DOC, ready, readyFn);
//   }
//   fireReady = $.noop; //隋性函数，防止IE9二次调用_checkDeps
// }
//
// function doScrollCheck() {
//   try { //IE下通过doScrollCheck检测DOM树是否建完
//     html.doScroll("left");
//     fireReady();
//   } catch (e) {
//     setTimeout(doScrollCheck);
//   }
// }
// ;
// if (!DOC.readyState) {
//   var readyState = DOC.readyState = DOC.body ? "complete" : "loading";
// }
// if (DOC.readyState === "complete") {
//   fireReady(); //如果在domReady之外加载
// } else {
//   $.bind(DOC, ready, readyFn = function() {
//     if (W3C || DOC.readyState === "complete") {
//       fireReady();
//       if (readyState) { //IE下不能改写DOC.readyState
//         DOC.readyState = "complete";
//       }
//     }
//   });
//   if (html.doScroll) {
//     try { //如果跨域会报错，那时肯定证明是存在两个窗口
//       if (window.eval === parent.eval) {
//         doScrollCheck();
//       }
//     } catch (e) {
//       doScrollCheck();
//     }
//   }
// }
window.iFramework = window.$ = iFramework;
module.exports = iFramework;
